<?php
/***********************************************
* CONTENIDO MODUL - OUTPUT
*
* Modulname  :      Registrierung
* Author(s)   :     Uwe Köthen, pixelparts, HerrB, Viktor Lehmann
* Copyright   :     pixelparts, Uwe Köthen :: TONE2TONE e.K., Viktor Lehmann
* Created     :     31.03.2006 / Aug 2008
************************************************/

cInclude('frontend', 'includes/class.phpmailer.php');
cInclude('frontend', 'includes/functions.t2t.php');

array_stripslashes($_POST);

// Für meinen Kunden definiere ich in einem extra Modul diverse seitenübergreifende Variablen. 
// Diese kommen normalerweise aus Mandanteneinstellungen (sprachabhängig, sprachunabhängig).
// Beispielhaft habe ich die für dieses Modul wichtigen Variablen hier mal fest definiert.
// Die zweite Klammer definiert die Sprachnummer für diesen String, z.B. 1=deutsch und kann später über $lang wieder angesprochen werden.

$bcvar["Herr"][1] = "Herr";
$bcvar["Frau"][1] = "Frau";
$bcvar["salutation_male"][1] = "Sehr geehrter Herr";
$bcvar["salutation_female"][1] = "Sehr geehrte Frau";
$bcvar["footer"][1] = "Mit freundlichen Grüßen, Ihr Herr Mustermann";
$bcvar["impressum"][1] = "Mailimpressum";
$bcvar["sendername"] = "Mail von Max Mustermann";

// Die Dropdownroutinen speisen sich aus Arrays, die in jeder Sprache da sein müssen.
// Auch diese kommen im echten Projekt aus Mandanteneinstellungen.
// In der Datenbank gespeichert und verglichen werden später nur die Werte der Sprache 1.
$set_language[1] = "deutsch;english;francais;espanol;italiano";
$set_language[2] = $set_language[1];
$set_language[3] = $set_language[1];
$set_language[4] = $set_language[1];
$set_language[5] = $set_language[1];
$set_language[6] = $set_language[1];
$set_land[1]     = "Afghanistan;Albania;Algeria;Angola;Argentina;Armenia;Australia;Austria;Azerbaijan;Bahamas;Bahrain;Bangladesh;Belarus;Belgium;Belize;Benin;Bermuda;Bhutan;Bolivia;Bosnia and Herzegovina;Botswana;Brazil;Brunei;Bulgaria;Burkina Faso;Burundi;Cambodia;Cameroon;Canada;Central African Republic;Chad;Chile;China;Colombia;Congo;Costa Rica;Cote d'Ivoire;Croatia;Cuba;Cyprus;Czech Republic;Denmark;Djibouti;Dominican Republic;Ecuador;Egypt;El Salvador;Equatorial Guinea;Eritrea;Estonia;Ethiopia;Finland;France;Gabon;Gambia;Georgia;Germany;Ghana;Greece;Guatemala;Guinea;Guyana;Haiti;Honduras;Hong Kong SAR;Hungary;Iceland;India;Indonesia;Iran;Iraq;Ireland;Israel;Italy;Jamaica;Japan;Jordan;Kazakhstan;Kenya;Korea North;Korea South;Kuwait;Kyrgyzstan;Laos;Latvia;Lebanon;Lesotho;Liberia;Libya;Lithuania;Luxembourg;Macau SAR;Macedonia;Madagascar;Malawi;Malaysia;Mali;Malta;Mauritania;Mauritius;Mexico;Moldova;Mongolia;Montenegro;Morocco;Mozambique;Myanmar;Namibia;Nepal;Netherlands;New Zealand;Nicaragua;Niger;Nigeria;Norway;Oman;Pakistan;Panama;Paraguay;Peru;Philippines;Poland;Portugal;Puerto Rico;Qatar;Romania;Russia;Rwanda;Saudi Arabia;Senegal;Serbia;Sierra Leone;Singapore;Slovakia;Slovenia;Somalia;South Africa;Spain;Sri Lanka;Sudan;Suriname;Swaziland;Sweden;Switzerland;Syria;Taiwan;Tajikistan;Tanzania;Thailand;Togo;Trinidad and Tobago;Tunisia;Turkey;Turkmenistan;Uganda;Ukraine;United Arab Emirates;United Kingdom;United States;Uruguay;Uzbekistan;Venezuela;Vietnam;Western Sahara;Yemen;Yugoslavia;Zaire;Zambia;Zimbabwe;Others";
$set_land[2]     = $set_land[1];
$set_land[3]     = $set_land[1];
$set_land[4]     = $set_land[1];
$set_land[5]     = $set_land[1];
$set_land[6]     = $set_land[1];


// Initialisation
$oClientLang = new cApiClientLanguage(false, $client, $lang);
$oClient     = new cApiClient($client);
$oRecipients = new NewsletterRecipientCollection();

$oFEUser = new cApiFrontendUser();
$oFEUser->loadByPrimaryKey($auth->auth["uid"]); # Ist ja nur einer und der muss existieren, da nur in geschütztem Bereich sinnvoll

$godmode = ($auth->auth["uid"] != "nobody" ) ? true : false ;

$sMessage = "";
$errMessage = mi18n("error_main");
$sucMessage = $godmode ?  mi18n("success_godmode") : mi18n("success_main");



$errCSS  = "<style type='text/css'><!-- #contactForm label#";
$errCSS2 = " {background-image: url('images/error2.png'); background-repeat: no-repeat;} --></style>";
$anredecheck = " checked='checked' ";

$tpl = new cTemplate();
$tpl->reset();

# Labels definieren
$hdl_person = ( $godmode ) ? mi18n(" Kontaktdaten") : mi18n("Meine Kontaktdaten") ;
$hdl_firma = ( $godmode ) ? mi18n(" Rechnungsanschrift") : mi18n("Angaben zu meiner Firma") ;


    $tpl->set("s", "HDL_PERSON", $hdl_person);
    $tpl->set("s", "HDL_FIRMA", $hdl_firma);
    $tpl->set("s", "HDL_NEWSLETTER", mi18n("Newsletter"));
    $tpl->set("s", "ANREDE", mi18n("Anrede"));
    $tpl->set("s", "ANREDE_OPTION1", $bcvar["Herr"][$lang]);
    $tpl->set("s", "ANREDE_OPTION2", $bcvar["Frau"][$lang]);
    $tpl->set("s", "NACHNAME", mi18n("Nachname"));
    $tpl->set("s", "VORNAME", mi18n("Vorname"));
    $tpl->set("s", "FIRMA", mi18n("Firmenname"));
    $tpl->set("s", "STRASSE", mi18n("Straße, Nr."));
    $tpl->set("s", "PLZORT", mi18n("PLZ, Ort"));
    $tpl->set("s", "TELEFON", mi18n("Telefon"));
    $tpl->set("s", "FAX", mi18n("Fax"));
    $tpl->set("s", "EMAIL", mi18n("E-Mail"));
    $tpl->set("s", "LAND", mi18n("Land"));
    $tpl->set("s", "SPRACHE", mi18n("Sprache"));
    $tpl->set("s", "BENUTZERNAME", mi18n("Benutzername"));
    $tpl->set("s", "EMAIL_RPT", mi18n("E-Mail-Wiederholung"));
    $tpl->set("s", "BETREFF", mi18n("Betreff"));
    $tpl->set("s", "ANLIEGEN", mi18n("Text"));
    $tpl->set("s", "PFLICHTFELDER", mi18n("Bitte alle Felder ausfüllen"));
    $tpl->set("s", "ABSCHICKEN", mi18n("Änderungen sichern"));
    $tpl->set("s", "LOESCHEN", mi18n("löschen"));
    $tpl->set("s", "NEWSLETTER_TEXT", "<strong>".mi18n("newsletter_info")."</strong><br>".mi18n("newsletter_info2"));
  $tpl->set('s', 'FORM_ACTION', 'front_content.php?idcatart='.$idcatart);

unset($recipient); // Unset any existing recipient objects - note, that it must be $recipient for the plugins...

/**** eigentlich wäre der Newsletter unnötig, aber wir schreiben ihn fort: a) für die Zukunft und b) weil im Anmeldeprozess die Mail anhand der registrierten Mailadressen überprüft wird, und ich das aus Zeitgründen derzeit nicht umschreiben will. Hat bei WCM funktioniert, damit wollen wir es belassen! ***/
$aSettings   = array();
$aSettings['JoinSel']         = $oClientLang->getProperty('newsletter', 'joinsel');
$aSettings['JoinMultiple']    = $oClientLang->getProperty('newsletter', 'joinmultiple');
$aSettings['JoinGroups']      = $oClientLang->getProperty('newsletter', 'joingroups');
$aSettings['JoinMessageType'] = $oClientLang->getProperty('newsletter', 'joinmessagetype');
$aSettings['FrontendLink']    = $oClient->getProperty('newsletter', 'frontendlink'); # Note: Stored for client, as frontendusers are language independent
$aSettings['FrontendConfirm'] = "CMS_VALUE[5]";
$aSettings['FrontendDel']     = "CMS_VALUE[6]";
$aSettings['SenderEMail']     = $oClient->getProperty('global', 'sender-email'); # This one could be recycled by other modules...
$aSettings['HandlerID']       = $oClientLang->getProperty('newsletter', 'idcatart');

// If there is no selection option set or if no groups has been selected, activate option Default
   if ($aSettings['JoinSel'] == '' || $aSettings['JoinGroups'] == '') {
      $aSettings['JoinSel'] = "Default";
   }
   if ($aSettings['FrontendConfirm'] == '') {
      $aSettings['FrontendConfirm'] = "ActivateUser";
   }
   if ($aSettings['FrontendDel'] == '') {
      $aSettings['FrontendDel'] = "DeleteUser";
   }
   

if ($_POST["doaction"] == "subscribe") {

   // Daten überprüfen (Pflichtfelder)
   $inputError = false;
   
   if ( $_POST["Anrede"] == "" ) {
      print $errCSS."Anrede".$errCSS2; $inputError = true;
   }  
   if (trim($_POST["Vorname"]) == "" || strlen($_POST["Vorname"]) > 50) {
      print $errCSS."Vorname".$errCSS2; $inputError = true;
   }  
   if (trim($_POST["Nachname"]) == "" || strlen($_POST["Nachname"]) > 100) {
      print $errCSS."Nachname".$errCSS2; $inputError = true;
   }
   if (trim($_POST["Strasse"]) == "" || strlen($_POST["Strasse"]) > 100) {
      print $errCSS."Strasse".$errCSS2; $inputError = true;
   }  
   if (trim($_POST["PLZ"]) == "" || strlen($_POST["PLZOrt"]) > 20) {
      print $errCSS."PLZ".$errCSS2; $inputError = true;
   }
   if ($_POST["Ort"] == "" || strlen($_POST["Ort"]) > 100) {
      print $errCSS."PLZ".$errCSS2; $inputError = true;
   } 
   if ($_POST["City"] != "" ) {
	   $inputError = true; // SpamCheck; Feld ist unnötig, wird von Robotern aber ausgefüllt
   } 
   if ($_POST["Land"] == "") {
      print $errCSS."Land".$errCSS2; $inputError = true;
   }
   if (trim($_POST["EMail2"]) == "") {
      print $errCSS."EMail2".$errCSS2; $inputError = true;
   }
   if (   ($_POST["FirmaVorname"] != "" || $_POST["FirmaNachname"] != "" )  && $_POST["FirmaAnrede"] == "" ) {
      print $errCSS."FirmaAnrede".$errCSS2; $inputError = true;
   } 
   if (  $_POST["FirmaVorname"] != "" && $_POST["FirmaNachname"] == ""  ) {
      print $errCSS."FirmaNachname".$errCSS2; $inputError = true;
   } 
   
   //  Mailadresse überprüfen
   if (!isset($_POST['EMail']) || !$_POST['EMail']) {
      print $errCSS."EMail".$errCSS2; $inputError = true;
   } elseif (!isValidMail($_POST['EMail']) || strpos($_POST['EMail'], ",") != false || strpos($_POST['EMail'], ";") != false) {
      print $errCSS."EMail".$errCSS2; $inputError = true;
   } elseif ($oRecipients->emailExists($_POST['EMail'])) { /** Hier wird der Newsletterteil benötigt, um die doppelte E-Mail als Username auszuschließen **/
      print $errCSS."EMail".$errCSS2; $inputError = true; $errMessage = mi18n("email_exists");
   } elseif ($_POST['EMail'] != $_POST['EMail2']) {
      print $errCSS."EMail2".$errCSS2; $inputError = true;
   }  

   $sEMail = ereg_replace("\n", "", stripslashes($_POST['EMail']));
   $sEMail = ereg_replace("\r", "", $sEMail);
   $sName  = stripslashes(trim($_POST["Vorname"]))." ".stripslashes(trim($_POST["Nachname"]));

   if ( $inputError == false) {

        // Hier beginnt das aktive Eintragen. Alle Werte sind ok.
        
        //Der User wird in allen Sprachen in die Newslettergruppe aufgenommen.
        // Die vordere 0 bedeutet "User Account not confirmed yet".
        // Die hintere 1 heißt, der Empfänger erhält einen HTML Newsletter (0 wäre Text).
        
        $rememberlang = $lang;
        // Die Sprachvariable muss jetzt getürkt werden, damit die RCP-Klasse den User ordnungsgemäß in allen Sprachen aufnimmt.
        // Sonst wird der User mehrfach in der auf der Seite aktiven Sprache angelegt.
        $lang = 1; $recipient = $oRecipients->create($sEMail, $sName, 0, 1, 1); // 1=Deutsche Newslettergruppe
        $rcp_hash[1] = $recipient->get("hash");
        $lang = 2; $recipient = $oRecipients->create($sEMail, $sName, 0, 2, 1); // 2=Englische Newslettergruppe
        $rcp_hash[2] = $recipient->get("hash");
        $lang = 3; $recipient = $oRecipients->create($sEMail, $sName, 0, 3, 1); // 3=Spanische Newslettergruppe
        $rcp_hash[3] = $recipient->get("hash");
        $lang = 4; $recipient = $oRecipients->create($sEMail, $sName, 0, 4, 1); // 4=Französische Newslettergruppe
        $rcp_hash[4] = $recipient->get("hash");
        $lang = 5; $recipient = $oRecipients->create($sEMail, $sName, 0, 5, 1); // 5=Türkische Newslettergruppe
        $rcp_hash[5] = $recipient->get("hash");
        $lang = 6; $recipient = $oRecipients->create($sEMail, $sName, 0, 6, 1); // 6=Italienische Newslettergruppe
        $rcp_hash[6] = $recipient->get("hash");
        $lang = $rememberlang; //aktive Sprache zurücksetzen.
		
            
// Newsletter scharf schalten oder pausieren?
              


        $oRecipients->resetQuery(); 
        $oRecipients->setWhere("email", $_POST['EMail']);
        $oRecipients->query();
               
               while ($recipient = $oRecipients->next())
               {
                                                   
                // Tweak für den Kunden: Newsletter auf jeden Fall offline schalten, auch wenn er erfasst wird
                 if ( $recipient->get("idlang") == $lang  ) {
                    $recipient->set("deactivated", 1);
                    $recipient->store();
                 }

/***
                 if ( $recipient->get("idlang") == $lang && $_POST["newsletter"] == "ja" ) {
                  $recipient->set("deactivated", 0);
                  $recipient->store();
                  } else {
                  $recipient->set("deactivated", 1);
                  $recipient->store();                  
                  }
***/                 
               }



            $sMessage = $sucMessage;
            
            if ( $_POST["Anrede"] == "Herr" ) { $greetz = $bcvar["salutation_male"][$lang]; } else { $greetz = $bcvar["salutation_female"][$lang]; }
            $sBody = $greetz." ".$_POST["Nachname"].",\n\n";
            $sBody .= mi18n("mail_registration_body")."\n".$cfgClient[$client]['path']['htmlpath']."front_content.php?changelang=".$lang."&idcatart=".$aSettings['HandlerID']."&confirm=".$rcp_hash[$lang]."\n\n".$bcvar["footer"][$lang]."\n\n".$bcvar["impressum"][$lang];

            $oMail = new PHPMailer();
	   		$oMail->CharSet  = 'utf-8';
            $oMail->From     = $aSettings['SenderEMail'];
            $oMail->FromName = $bcvar["sendername"];
            $oMail->AddAddress($sEMail);
            $oMail->Mailer   = "mail";
            $oMail->Subject  = stripslashes(mi18n("mail_registration_subject"));
            $oMail->Body     = stripslashes($sBody);

			   if ( !$godmode) {
				   
				   $oMail->Send();
				   $sMessage = mi18n("mail_registration_display");
			   }

               if ($aSettings['FrontendLink'] == "enabled")
               {
                  $oFrontendUsers = new cApiFrontendUserCollection();


                     if ($frontenduser = $oFrontendUsers->create($sEMail)) // it's "frontenduser" (instead of oFrontendUser) for plugins...
                     {
                       $FEUserID = $frontenduser->get("idfrontenduser");
                       $oFEUser = new cApiFrontendUser();
                       $oFEUser->loadByPrimaryKey($FEUserID);
                       				 
						$recordcreatedby = ($auth->auth["uid"] != "nobody" ) ? $auth->auth["uid"] : $FEUserID ;
                       
                      $oFEUser->set("author", $recordcreatedby );
						 if ( $godmode ) {
							 $oFEUser->set("active", "1" ); 
							 $oFEUser->set("userconfirmed", 0 ); 
						 } else {
						 	$oFEUser->set("userconfirmed", 1 ); 
						 }
					  $oFEUser->store();
                      $oFEUser->setProperty("address", "title", $_POST["Anrede"]);
                      $oFEUser->setProperty("address", "surname", trim($_POST["Nachname"]));
                      $oFEUser->setProperty("address", "name", trim($_POST["Vorname"]));
                      $oFEUser->setProperty("address", "zip", trim($_POST["PLZ"]));
                      $oFEUser->setProperty("address", "city", trim($_POST["Ort"]));
                      $oFEUser->setProperty("address", "street", trim($_POST["Strasse"]));
                      $oFEUser->setProperty("address", "land", $_POST["Land"]);
                      $oFEUser->setProperty("address", "company", trim($_POST["Firma"]));
                      $oFEUser->setProperty("address", "telefone", trim($_POST["Telefon"]));
                      $oFEUser->setProperty("address", "fax", trim($_POST["Fax"]));
                      $oFEUser->setProperty("address", "comptitle", $_POST["FirmaAnrede"]);
                      $oFEUser->setProperty("address", "compname", trim($_POST["FirmaVorname"]));
                      $oFEUser->setProperty("address", "compsurname", trim($_POST["FirmaNachname"]));
                      $oFEUser->setProperty("address", "sprache", $_POST["Sprache"] );
                        // Note: You should check the values you get (safety)!!!

                        if ($aSettings['FrontendConfirm'] == "ActivateUser")
                        {
                           // Inform about frontend user account creation
                           $sMessage .= "<br><br>".mi18n("activation_message");
                        }
                     } else {
                        $sMessage .= "<br><br>".mi18n("account_creation_error");
                     }
 
               }


            print "<p id='sucMsg'>".str_replace("%%", $FEUserID, $sucMessage )."</p>";

      }  else { // if input error false ende

       print "<p id='errMsg'>".$errMessage."</p>";
       
    } // else input error false ende
      
      
  } else { //if subscribe ende

    # Daten auf null setzen, falls zum ersten Mal geladen
    
        $_POST["godmode"]       = $godmode;
        $_POST["Anrede"]        = "";
        $_POST["Nachname"]      = "";
        $_POST["Vorname"]       = "";
        $_POST["PLZ"]           = "";
        $_POST["Ort"]           = "";
        $_POST["Strasse"]       = "";
        $_POST["Land"]          = "";
        $_POST["Firma"]         = "";
        $_POST["Telefon"]       = "";
        $_POST["Fax"]           = "";
        $_POST["FirmaAnrede"]   = "";
        $_POST["FirmaVorname"]  = "";
        $_POST["FirmaNachname"] = "";
        $_POST["Sprache"]       = $lang;
        $_POST["EMail"]         = "";
        $_POST["EMail2"]        = "";
        $newsstatus             = "checked";
        $herr                   = "";
        $frau                   = "";
        $firmaherr                   = "";
        $firmafrau                   = "";
   
   }  //else subscribe ende


if ( $_POST["newsletter"] == "ja" ) { $newsstatus = "checked"; } else {$newsstatus = ""; }
       
if ( $_POST["Anrede"] != "" ) {
              if ( $_POST["Anrede"] == "Herr" ) { $herr = $anredecheck; } else {$frau = $anredecheck; } 
           } else {
              $herr = ""; $frau = "";
}
if ( $_POST["FirmaAnrede"] != "" ) {
              if ( $_POST["FirmaAnrede"] == "Herr" ) { $firmaherr = $anredecheck; } else {$firmafrau = $anredecheck; } 
           } else {
              $firmaherr = ""; $firmafrau = "";
}
        
    $tpl->set('s', 'herrval', $herr);
    $tpl->set('s', 'godmode', $godmode);
    $tpl->set('s', 'frauval', $frau);
    $tpl->set('s', 'vornameval', trim($_POST["Vorname"]));
    $tpl->set('s', 'nachnameval', trim($_POST["Nachname"]));
    $tpl->set('s', 'firmaval', trim($_POST["Firma"]));
    $tpl->set('s', 'strasseval', trim($_POST["Strasse"]));
    $tpl->set('s', 'telefonval', trim($_POST["Telefon"]));
    $tpl->set('s', 'faxval', trim($_POST["Fax"]));
    $tpl->set('s', 'emailval', trim($_POST["EMail"]));
    $tpl->set('s', 'email2val', trim($_POST["EMail2"]));
    $tpl->set('s', 'plzval', trim($_POST["PLZ"]));
    $tpl->set('s', 'ortval', trim($_POST["Ort"]));
    $tpl->set('s', 'landval', createSel($set_land, $_POST["Land"], "Land", $lang));
    $tpl->set('s', 'newsval', $newsstatus);
    $tpl->set('s', 'firmaherrval', $firmaherr);
    $tpl->set('s', 'firmafrauval', $firmafrau);
    $tpl->set('s', 'firmavornameval', trim($_POST["FirmaVorname"]));
    $tpl->set('s', 'firmanachnameval', trim($_POST["FirmaNachname"]));
    $tpl->set('s', 'strasseval', trim($_POST["Strasse"]));
    $tpl->set('s', 'plzval', trim($_POST["PLZ"]));
    $tpl->set('s', 'ortval', trim($_POST["Ort"]));
    $tpl->set('s', 'spracheval', createSelNumSimple($set_language, $_POST["Sprache"], "Sprache", $lang));
    $tpl->set('s', 'WEITER', "");

$tpl->generate('templates/formular_kundendaten.html');

?>